#read the files defining DV locations and names
dv2=c(1,9,17,25,33,41,49,57,2,10,18,26,34,42,50,58);
dv3=c(3,11,19,27,35,43,51,59,4,12,20,28,36,44,52,60);
dv4=c(5,13,21,29,37,45,53,61,6,14,22,30,38,46,54,62);
dv5=c(7,15,23,31,39,47,55,63,8,16,24,32,40,48,56,64);
N.dv<-cbind(dv2,dv3,dv4,dv5)
dimnames(N.dv)=list(NULL,as.character(201:204))
#read in the calibration and function data
dvtag0<-read.table("c:/qcls/rprogs/dvtag.txt",header=T,sep="",as.is=T)# define calcr10 function
dvtag<-as.matrix(dvtag0[,c(1,4:11)])
nn<-scan("infile",n=3,what=character(),skip=1) ; flt<-scan("flt",what=character())
print(nn)
#must be run using R CMD from the c:\qcls\data\flt folder
postscript(file=paste("c:/QCLS/DATA/",flt,"/analysis/Fig.",flt,".ps",sep=""),horizontal=F)
par(mfrow=c(2,2),mar=c(4,4,2,.5))
for(id in 201:204){
readfile<-paste("c:/QCLS/DATA/",flt,"/CR10/O",nn[1],".",id,sep="")
O.id<-as.matrix(read.table(readfile,header=T))
for(j in 1:16){    # calibrate the channels and write the final to the O file
dv<-N.dv[,as.character(id)][j]
yl<-dvtag[dv,c("RANGE1","RANGE2")];if(sum(!is.finite(yl))>0)yl<-range(dum,na.rm=T)
plot(O.id[,1],O.id[,j+5],ylim=yl,type="l",ylab=dvtag0[dv,3],main=paste("dv=",dv,dvtag0[dv,2]))
}
}
dev.off()
system(paste("cmd /c ps2pdf c:/QCLS/DATA/",flt,"/analysis/Fig.",flt,".ps",sep=""))
#plot the the str and stc files
system("cmd /c dir /b CO2\\*.str > co2_str.txt"); co2.str.file<-scan("co2_str.txt",what=character())
system("cmd /c dir /b DUAL\\*.str > dual_str.txt"); dual.str.file<-scan("dual_str.txt",what=character())
cc.str<-as.matrix(read.table(paste("c:/QCLS/DATA/",flt,"/CO2/",co2.str.file,sep=""),skip=1,header=F))
cc.str[,1]=cc.str[,1]-3281990400.
day<-cc.str[,1]/86400+1 
start.end<-scan(paste(infile.path,"\\infile",sep=""),n=6,skip=4)
lim.day<-c(start.end[1]+start.end[2]/24+start.end[3]/(24*60),start.end[4]+start.end[5]/24+start.end[6]/(24*60))
lday<-day>lim.day[1] & day<lim.day[2]  # start of real data
if(sum(lday)>0){
  hr<-day[lday]*24; hrp<-unique(trunc(hr));n7<- match(hrp,round(hr,3));l7<-!is.na(n7)
  cc<-cbind(cc.str[lday,],day[lday]); dimnames(cc)<-list(NULL,c("GMTs","CO2.str","GMT_day"))
  if(PP==1)png(paste(infile.path,"\\analysis\\","CO2_raw",fileid,".png",sep=""))
  par(mar=c(4,4,4,1)+.15)
  plot(cc[,c(3,2)],type="l")
  title(line=2.5,main=fileid) 
  axis(side=3,at=cc[n7[l7],3],labels=as.character(hrp[l7]%%24))
if(PP==1)dev.off()
}
#======================o======================================================
dd.str<-as.matrix(read.table(path2strd,skip=1,header=F) )
dimnames(dd.str)<-list(NULL,c("GMTs","CH4","N2O","CO") )
dd.str[,1]=dd.str[,1]-3281990400.   #Jan 1 2008 igor time seconds
ldday<-dd.str[,1]/86400+1 
if(sum(ldday)>0){
  ldday<-dday>lim.day[1] & dday<lim.day[2]  # start of real data
  dhr<-dday[ldday]*24; dhrp<-unique(trunc(dhr));dn7<- match(dhrp,round(dhr,3));dl7<-!is.na(dn7)
  dd<-cbind(dd.str[ldday,],dday[ldday]);dimnames(dd)<-list(NULL,c("GMTs","CH4","N2O","CO","Day") )
  if(PP==1)png(paste(infile.path,"\\analysis\\","DUAL_CO2_raw",fileid,".png",sep=""),height=1000,width=800)
  par(mfrow=c(2,2),mar=c(4,4,4,1)+.15)
  for(i in c("CH4","N2O","CO")){
  plot(dd[,c("GMTs",i)],type="l",axes=F);box();axis(2)
  axis(1,at=dd[dn7[dl7],1],labels=as.character(round(dd[dn7[dl7],1]%%86400,-1)))
  title(line=2.5,main=paste("Raw str",i,fileid)) 
  axis(side=3,at=dd[dn7[dl7],1],labels=as.character(dhrp[dl7]%%24))}
  plot(cc[,c(1,2)],type="l",axes=F);box();axis(2)
  axis(1,at=cc[n7[l7],1],labels=as.character(round(cc[n7[l7],1]%%86400,-1)))
  title(line=2.5,main=paste("Raw str CO2",fileid)) 
  axis(side=3,at=cc[n7[l7],1],labels=as.character(hrp[l7]%%24))
  if(PP==1)dev.off()
}
#
}
dev.off()
#============================================================================
