c23456789012345678901234567890123456789012345678901234567890123
C
C  Balloon DATA REDUCTION CODE -- LICOR CO2 -- DATA CONVERSION
C  HOUSEKEEPING DATA TEMPERATURES/FLOWS/PRESSURES/SOLENOIDS
C  Fan (October, 1992) ;  modified for new file names by scw Nov 1992
C  picks up 6-char file identifier from "infile"
c  revised for data format of 2nd SPADE deployment March 1993 scw
C  v1.0 modified for the balloon instrument May 1996 scw
C
C  -revised 10 Jan 1997 by bcd to account for elimination of
C   sample solenoid. Status bit of vent solenoid is used instead
C   (inverted logically) and mapped into status bit previously
C   used for sample solenoid (modified "F215DATA").
C
C -revised 21 Jan 1997 to include bottle and regulator pressures in the
C  200 Data
C
C  ***** CR10 DATA ID TABLE *****
C
C  FIELD ID   FIELD LENGTH   FIELD DATA   DATA PERIOD
C       111             43          CO2   4 hz x 10 s
C       200             45      standby          15 s
C       201             16   house keep           1 s
C       215             58   house keep          15 s
c Failure and event record IDs
c       001              3   telemetry <CR>:  ignore this field
C	188		23   initialize/disable
C	204		 3   pump speed test fail/restart needed
C	208		 3   pump temperature alert
C	209		 3   pump restart x10 fail:  5 min delay to retry
C       222             23   Power supply T fail+CNTRL data
C       250		 3   Drop command recvd
C       277              3   float standby mode initiated
C	301		 3   PVTC turned off:  overheated
C	302		 3   GDTC turned off:  overheated
C	303		 3   BPTC turned off:  overheated
C	304		 3   PATC turned off:  overheated
C	400		24   Landing
C  
c  MODE KEYS

c  1 SLOW POWER UP
c  2 FAST POWER UP
c  3 REGULAR STANDBY MODE (TC's enabled)
c  4 PUMP AND GAS FLOW START-UP
c  5 FULL OPERATION / INITIAL CALIBRATION (CALMODE: 1="full", 2="fast"; see 215 data table)
c  6 FULL OPERATION / AUTO CALIBRATION (1 min, timing = ER-2)
c  7 "FLOAT" STANDBY MODE
c  8 PUMP TEMPERATURE ALERT STANDBY MODE
c  9 PUMP RESTART STANDBY MODE
c  10 LANDING MODE -- power disabled
c=============================================================================
C  FIELD 111 DATA: ID, HHMM, SS.SS, 40*[CO2] (4 HZ)
c =============================================================================
c  200 DATA
c  
c  1. 200  Output array identification
c  2. HHMM  2400 time
c  3. Seconds   e.g., 1 or 1.13 or 1.125
c  4. Pr-Amb  [x-zero(T)]*0.31661;<- zero(T_ByPs)=16.995+0.42*T-.002654*T*T torr
c  5. T-cell1 30K Thermistor conversion = TEMP(x) -> deg C
c  6. T-PVint
c  7. T-PVext
c  8. T-mux
c  9. T-rack
c  10. T-instr
c  11. T-batt
c  12. T-GsDk3
c  13. T-ByPs
c  14. T-PmpAy
c  15. Tc-PV Temp Controller conversion = TEMPc(x) -> deg C
c  16. Tc-GD
c  17. Tc-BP
c  18. Tc-PA
c  19. Pr_PV 1.034*(x-500.) -> torr
c  20. Current x*0.02 -> Amps
c  21. T-Pmp#1 30K Thermistor conversion = TEMP(x) -> deg C
c  22. T-Pmp#2 "
c  23. T-PwrSp "
c  24. T-dmy "
c  25. sol-REF Control: 1 = On, 0 = Off
c  26. sol-ZER "
c  27. sol-PRI "
c  28. sol-LS "
c  29. sol-HS "
c  30. sol-SAM "
c  31. sol-VENT "
c  32. PVTC Control: 0= On, 1= Off
c  33. GDTC "
c  34. BPTC "
c  35. PATC "
c  36. P-Ctrl-1 "
c  37. Pmp#1 "
c  38. Pmp#2 "
c  39. P-Ctrl-inl "
c  40. SET-P#1 D-to-A:  0 or Setpoint in mV=3000mV
c  41. SET-P#2 "                           =3000mV
c  42. SET-Pinl "                          =1128mV
c  43. Port-Read Sum of Ports 7&8:   7 high = 64; 8 high = 128; lows=0
c  44. PS-Enable Control: 1 = On, 0 = Off
c  45. MODE See mode key
c  
c =============================================================================
c  
c  201 DATA
c  
c  1. 201 Output array identification
c  2. HHMM 2400 time
c  3. Seconds e.g., 1 or 1.13 or 1.125
c  4. Pr-Amb [x-zero(T)]*0.31661; zero(T-ByPs)=16.995+0.42*T-0.002654*T*T ->
c  5. Pr-Byp [x-zero(T)]*0.1571; zero(T-ByPs)=14.9+0.2475*T-0.001485*T*T -> torr
c  6. Pr-Cell [x-zero(T)]*0.1587; zero(T-PVint)=20,98-0.16*T+0.00051*T*T ->
c  7. Pr-Diff x*4 -> mtorr
c  8. Fl-Byp flow(x)=4.10+0.03837*(x-500.)+1.603e-4*(x-500.)**2 ->sccm
c  9. Fl-Sam "
c  10. Fl-Ref "
c  11. Pr-CalMan [x-zero(T)]* 0.6354;zero(T-PVint)= 29.328-0.06*T+0.000149*T*T -> torr
c  12. Pr-P#1inl [x-zero(T)]*0.1585; zero(T-PmpAy)=4.37+0.3225*T-0.0025*T*T -> torr
c  13. Pr-P#2inl [x-zero(T)]*0.3160; zero(T-PmpAy)=44.72-0.495T+0.005*T*T -> torr
c  14. Speed-P1 x*4
c  15. Speed-P2 x*4
c  16. MODE See mode key
c  
c =============================================================================
c  215 DATA
c  1. 215 Output array identification
c  2. HHMM 2400 time
c  3. Seconds e.g., 1 or 1.13 or 1.125
c  4. T-cell1 30K Thermistor conversion = TEMP(x) r (C
c  5. T-cell2 "
c  6. T-PVint "
c  7. T-PVext "
c  8. Stat-Pmp1 x*2
c  9. Stat-Pmp2 x*2
c  10. T-mux 30K Thermistor conversion = TEMP(x) r (C
c  11. T-rack "
c  12. T-instr "
c  13. T-batt "
c  14. Preg-REF [x-6.7]*0.06547 -> psi
c  15. Preg-PRI [x+69.2]*0.06602 -> psi
c  16. Preg-LS [x-100.7]*0.06625 -> psi
c  17. Preg-HS [x-109.8]*0.06559 -> psi
c  18. HiP-REF [x-61.7]*1.30548 -> psi
c  19. HiP-PRI [x+38.2]*1.29366 -> psi
c  20. HiP-LS [x-24.6]*1.30662 -> psi
c  21. HiP-HS [x-16.1]*1.31579 -> psi
c  22. T-GsDk2 30K Thermistor conversion = TEMP(x) -> deg C
c  23. T-GsDk3 "
c  24. T-ByPs "
c  25. T-PmpAy "
c  26. Tc-PV Temp Controller conversion = TEMPc(x) -> deg C
c  27. Tc-GD "
c  28. Tc-BP "
c  29. Tc-PA "
c  30. Det-Rdy Ready ( 1100 mV
c  31. Pr_PV 1.034*(x(500) r torr
c  32. Current x*0.02rAmps
c  33. T-Pmp#1 30K Thermistor conversion = TEMP(x) -> deg C
c  34. T-Pmp#2 "
c  35. T-PwrSp "
c  36. T-dmy "
c  37. sol-REF Control: 1 = On, 0 = Off
c  38. sol-ZER "
c  39. sol-PRI "
c  40. sol-LS "
c  41. sol-HS "
c  42. sol-SAM "
c  43. sol-VENT "
c  44. PVTC Control: 0= On, 1= Off
c  45. GDTC "
c  46. BPTC "
c  47. PATC "
c  48. P-Ctrl-1 "
c  49. Pmp#1 "
c  50. Pmp#2 "
c  51. P-Ctrl-inl "
c  52. SET-P#1 D-to-A:  0 or Setpoint in mV =3000mV
c  53. SET-P#2 "                                             =3000mV
c  54. SET-Pinl "                                             =1128mV
c  55. Port-Read Sum of Ports 7&8:   7 high = 64; 8 high = 128; lows = 0
c  56. PS-Enable Control: 1 = On, 0 = Off
c  57. FLOATcnt Seconds elapsed since altitude higher than 10 Torr not cnt'd after drp cmd
c  58. CalMode 1 = full (8 min: z,ls,hs,pri,repeat); 2 = fast (4min:z,ls,hs,pri/1min ea)
c  
c =============================================================================
c conversion functions
c  
c  TEMPc(x)= - 17.415 + 0.03805*x - 6.503e-6*x*x
c note change of sign from ER-2:  these are differential channels
c  
c  TEMP(x1):   x=-x1; xx = 30100.*x/(2500.-x)
c  y = alog(xx)
c  z = 9.3548e-4 + (2.2071e-4 + 6.8076e-8*y + 1.2407e-7*y*y)*y  
c  TEMP=1/Z-273.15
c  note these are still CR10 single-ended channels, thus the first line +/-
C  ***** END OF TABLE *****
C
      CHARACTER*64 FIRSTLINE
      CHARACTER*24 FILENAME
c dims=recl-3
      REAL F111DATA(40)
      REAL F200DATA(50)
      REAL F201DATA(13)
      REAL F215DATA(55)
      REAL UTIME,TEMP
      INTEGER HOUR,MINT
      INTEGER ISOL(15)
C
      OPEN(12,FILE='infile',STATUS='old',recl=512,access='sequential')
      read(12,'(A24)')filename
	close(12)
      OPEN(22,FILE='D'//filename(2:7)//'.200',STATUS='old',recl=512,access='sequential')
      OPEN(23,FILE='D'//filename(2:7)//'.201',STATUS='old',recl=512,access='sequential')
      OPEN(25,FILE='D'//filename(2:7)//'.215',STATUS='old',recl=512,access='sequential')
C direct files (CR-10 encoded), Dyrmmdd.ijk; converted to Oyrmmdd.ijk
      OPEN(32,FILE='O'//filename(2:7)//'.200',STATUS='unknown',recl=512,access='sequential')
      OPEN(33,FILE='O'//filename(2:7)//'.201',STATUS='unknown',recl=512,access='sequential')
      OPEN(35,FILE='O'//filename(2:7)//'.215',STATUS='unknown',recl=512,access='sequential')
      READ(22,'(A64)') FIRSTLINE
      WRITE(32,'(A64)') FIRSTLINE
      READ(23,'(A64)') FIRSTLINE
      WRITE(33,'(A64)') FIRSTLINE
C*      READ(24,'(A64)') FIRSTLINE
      READ(25,'(A64)') FIRSTLINE
      WRITE(35,'(A64)') FIRSTLINE
c line counters
	n200=1 
        n201=1 
        n215=1  
c read ID=200 data from split_hi:
200   READ(22,20,ERR=209, END=215) UTIME,HOUR,MINT,SECD
        n200=n200+1
      READ(22,30) F200DATA,tbypass
	tt=temp(tbypass)
	Z1=16.995+0.42*tt-0.002654*tt*tt
      F200DATA( 1)=0.31661*(f200data(1)-z1)
c ambient pressure
        do 1001 jj=2,8
	f200data(jj)=temp(f200data(jj)) 
1001    continue
        do jj=17,19
	f200data(jj)=temp(f200data(jj)) 
	enddo
        do jj=26,29
	f200data(jj)=temp(f200data(jj)) 
	enddo
        do jj=20,23
	f200data(jj)=tempc(f200data(jj)) 
	enddo
c	f200data(16)=(f200data(19)-500.)*1.034
        f200data(24)=f200data(24)*1.034
        f200data(25)=f200data(25)*0.02
        f200data(9)=(f200data(9)-6.7)*0.06547
        f200data(10)=(f200data(10)+69.2)*0.06602
        f200data(11)=(f200data(11)-100.7)*0.06625
        f200data(12)=(f200data(12)-109.8)*0.06559
        f200data(13)=(f200data(13)-61.7)*1.30548
        f200data(14)=(f200data(14)+38.2)*1.29366
        f200data(15)=(f200data(15)-24.6)*1.30662
        f200data(16)=(f200data(16)-16.1)*1.31579
C  corr for zero, convert to torr
      WRITE(32,20) UTIME,HOUR,MINT,SECD
      WRITE(32,40) F200DATA
      GOTO 200
209   print *,'Error reading D*.200, line ',n200
215   READ(25,20,ERR=2011,END=201) UTIME,HOUR,MINT,SECD
      n215=n215+1
      READ(25,30) F215DATA
C
C  Modification for elimination of sample solenoid. Status bit of
C  vent solenoid is used instead (inverted logically) and mapped
C  into status bit previously used for sample solenoid. bcd 10 Jan 97
C
      F215DATA(39) = -F215DATA(40) + 1  
C
c  LOOP DOES ALL THERMISTOR CONVERSIONS, -1 for op-amp inversion
        do 1003 jj=1,10
      if(jj.ne.5.and.jj.ne.6)then
	F215DATA( jj)=TEMP(F215DATA( jj)) 
	else
	F215DATA( jj)=2.*(F215DATA( jj)) 
	endif
1003    continue
	do jj=19,22
	F215DATA( jj)=TEMP(F215DATA( jj)) 
	F215DATA( jj+11)=TEMP(F215DATA( jj+11)) 
	F215DATA( jj+4)=TEMPc(F215DATA( jj+4)) 
c this loop converts 19-22, 30-33 and 23-26
	enddo
C *** GET T(GD Reg) already converted FROM FIELD 215
	F215DATA(11)=(F215DATA(11)-6.7)*.06547
	F215DATA(12)=(F215DATA(12)+69.2)*.06602
	F215DATA(13)=(F215DATA(13)-100.7)*.06525
	F215DATA(14)=(F215DATA(14)-109.8)*.06559
	F215DATA(15)=(F215DATA(15)-61.7)*1.30548
	F215DATA(16)=(F215DATA(16)+38.2)*1.29366
	F215DATA(17)=(F215DATA(17)-24.6)*1.30662
	F215DATA(18)=(F215DATA(18)-16.1)*1.31579
c	F215DATA(28)=(F215DATA(28)-500.)*1.034
	F215DATA(28)=F215DATA(28)*1.034
	F215DATA(29)=F215DATA(29)*0.02
       do 1004 jj=1,15
      ISOL( jj)=F215DATA(jj+33)
	write(34,*)f215data(jj+33)
1004    continue
      WRITE(35,20) UTIME,HOUR,MINT,SECD
      WRITE(35,40) (F215DATA(I),I=1,33)
      WRITE(35,45) ISOL
      WRITE(35,40) (F215DATA(I),I=49,55)
      GOTO 215
2011  print *,'Error reading D*.215, line ',n215
201   READ(23,20,err=298,END=299) UTIME,HOUR,MINT,SECD
      n201=n201+1
      READ(23,30) F201DATA,tpvint,tbypass,tpmpay
        tbyp=temp(tbypass)
        tpv=temp(tpvint)
        tpmp=temp(tpmpay)
c ambient pressure C  T-dept zero
      ZERO=16.995+0.42*tbyp-.002654*tbyp*tbyp
      F201DATA( 1)=0.31661*(F201DATA(1)-ZERO)
c byp pressure
      ZERO=14.9+0.2475*tbyp-0.001485*tbyp*tbyp
      F201DATA( 2)=0.6284*(F201DATA(2)-ZERO)
c     F201DATA( 2)=0.1571*(F201DATA(2)-ZERO)
cell pressure
      ZERO=20.98-0.16*tpv+5.05e-4*tpv*tpv
c     F201DATA( 3)=0.1587*(F201DATA(3)-ZERO)
      F201DATA( 3)=0.6348*(F201DATA(3)-ZERO)
c diff pressure
      F201DATA( 4)=8.* F201DATA(4)
c flow byp
	f201data(5)=4.1+0.03837*(f201data(5)-500.)+1.603e-4*(f201data(5)-500.)**2
c flow sample
	f201data(6)=4.1+0.03837*(f201data(6)-500.)+1.603e-4*(f201data(6)-500.)**2
c flow reference
	f201data(7)=4.1+0.03837*(f201data(7)-500.)+1.603e-4*(f201data(7)-500.)**2
calMan pressure = (8)
      ZERO=29.328-0.06*tpv+0.000149*tpv*tpv
      F201DATA( 8)=0.6173*(F201DATA(8)-ZERO)
c (9)= Pr-P#1 inlet
      ZERO=4.37-0.3225*tpmp+2.5e-3*tpmp*tpmp
c     F201DATA( 9)=0.1585*(F201DATA(9)-ZERO)
      F201DATA( 9)=0.3170*(F201DATA(9)-ZERO)
c (10)= Pr-P#2 inlet
      ZERO=44.72-0.495*tpmp+0.005*tpmp*tpmp
      F201DATA(10)=0.3160*(F201DATA(10)-ZERO)
      F201DATA(11)=f201data(11)*4.
      F201DATA(12)=f201data(12)*4.
      WRITE(33,20) UTIME,HOUR,MINT,SECD
      WRITE(33,40) F201DATA
      GOTO 201
20    FORMAT(F8.1,2X,I2,2X,I2,2X,F5.2)
30    FORMAT(8(F9.2,1X))
40    FORMAT(8(F9.2,1X))
45    FORMAT(17I3)
298    print *,'Error reading D*.201, line ',n201
299   CLOSE(22)
      CLOSE(23)
C*      CLOSE(24)
      CLOSE(25)
      CLOSE(32)
      CLOSE(33)
      CLOSE(34)
      CLOSE(35)
      print*,'#  read ID200=',n200,' ID201=',n201,' ID215=',n215
      STOP
      END
C
      FUNCTION TEMP(X1)
      REAL TEMP,X,x1
C thermistor mv --> deg C
	x=-x1
      if (x .EQ. 2500.) then
	print *, 'Error: temp=-2500, repl by -999'
	TEMP=-999
	RETURN
      end if
      XX=30100.*X/(2500.-X)
      IF (XX .LE. 0.) THEN
       PRINT *,' Error: Neg Arg in TEMP(X)',X1,' repl by -999'
        TEMP=-999.
        RETURN
      END IF
      Y=ALOG(XX)
      Y2=Y*Y
      Y3=Y2*Y
      Z=9.3548E-4+2.2071E-4*Y+6.8076E-8*Y2+1.2407E-7*Y3
      TEMP=1./Z-273.15
      RETURN
      END
	function tempc(x)
C     temperature controller mv--> deg C //X=PrVs //X= Tc(GD)+2
      tempc= -17.415 +0.03805*X-6.503e-6*X*X
	return
	end
