	program SIGSPL_QCL
c23456789012345678901234567890123456789012345678901234567890123
c ****  QCL data procsessing code ***** | April 2008 scw
c ****     signal split by status  ***** |
c splits streaming files (TDLWintel *.str) into signal and cal files, 1s, & 10s median filtered
c 
      CHARACTER*50 FIRSTLINE,SKIPLINE,FILENAME,OP,FLT,VALFILE,skip5(5)
      CHARACTER*512 linebuf
      REAL*8 UTIME,median,UT_STS(36000)
      REAL*8 igor20080101,rtime,digor20080101,daystart,dayend,daytime
      INTEGER DAY,HOUR,MINT,twon(5),huntf,nus(5)
      INTEGER*2 ISOL(36,36000)
	data igor20080101/3281990400./,digor20080101/37986/,twon/1,2,4,8,16/,nus/32,33,34,35,36/
c read file names, paths, and start-stop info from 'infile'
      OPEN(12,FILE='infile',STATUS='old',recl=512,access='sequential')
      print*,'Reading from infile--contents: '
      read(12,'(A64)')FIRSTLINE,FLT,SKIPLINE,OP,skip5,VALFILE
      print 326,FIRSTLINE,FLT,SKIPLINE,OP,skip5,VALFILE
326   format(A64)
        read(12,'(F10.2)')daystart,dayend
        print*,'daystart,dayend: ',daystart,dayend
        close(12)
c  CREATE a status array for the whole flight, time selected via daystart, dayend
      print*,'Opening Status File: ',OP//'D'//FLT(1:lentrim(FLT))//'.STS'
      OPEN(26,FILE=OP//'D'//FLT(1:lentrim(FLT))//'.STS',STATUS='old',recl=512,access='sequential')
      READ(26,'(A64)') FIRSTLINE
c ===============loop through the status file, create a matrix between start and end times
c counter for the number of valid lines
	 nsts =1   
1     read(linebuf,*,err=999,end=2) UT_STS(nsts),DAY,HOUR,MINT,SECD,(ISOL(j,nsts),j=1,36)
         daytime=DAY + HOUR/24. + MINT/(24.*60.) + SECD
c  only keep times between the limits: 2 finished; 1 cycle back to read a new line
         if(daytime.ge.dayend)goto 2
         if(daytime.lt.daystart)goto 1
         nsts=nsts+1
      goto1
2	close(26)
        nsts=nsts-1
	print*,'read ',nsts-1,' records'
c       x--------------------------------------------
      write(99,28)((isl(i,j),j=1,5),imask(i),time60(i)
20    FORMAT(F8.1,2X,I2,2X,I2,2X,F5.2)
30    FORMAT(8(F9.2,1X))
40    FORMAT(8(F9.2,1X))
45    FORMAT(17I3)
28	format(5i4,2x,i4,2x,f9.2)
c	write(99,*)'number of 215 records=',n215
      OPEN(31,FILE='O'//filename(2:7)//'.ZER',STATUS='unknown',recl=512,access='sequential')
c zero 10s median ; primary ; lo-cal; hi-cal; sample; complete
      OPEN(32,FILE='O'//filename(2:7)//'.PRI',STATUS='unknown' ,recl=512,access='sequential')
      OPEN(33,FILE='O'//filename(2:7)//'.SLO',STATUS='unknown',recl=512,access='sequential')
      OPEN(34,FILE='O'//filename(2:7)//'.SHI',STATUS='unknown' ,recl=512,access='sequential')
      OPEN(35,FILE='O'//filename(2:7)//'.SAM',STATUS='unknown',recl=512,access='sequential')
      OPEN(37,FILE='O'//filename(2:7)//'.CON',STATUS='unknown' ,recl=512,access='sequential')
      print*,'sigspl_h opening ','D'//filename(2:7)//'.111'
      OPEN(22,FILE='D'//filename(2:7)//'.111',STATUS='old',recl=512,access='sequential')
c  licor output
      READ(22,'(A64)') FIRSTLINE
c read licor output file;  output median filter files, by status code; .CON
c file includes the status code.  Note that time in the .111 file is at the
c END (last reading) of each record.
c binary status word: bit#1:zero;2,primary;3, lo-std;4,hi-std;5,SAMPLE
      nhunt=1  
c  initial hunt guess
4     read(22,20,err=994,end=14)UTIME,HOUR,MINT,SECD
	read(22,30,err=994,end=14)co2mv
        n111=n111+1
        rtime=utime-5.   
c start time for block of 40 @ 4hz >>[corrected from fall pgm]<<
        nguess=max(nhunt,1)
        nhunt=huntf(time60,n215,utime,nguess) 
c find prev. status mask%
          if(nhunt.gt.0)then	
            do 1999 i=1,5
            if(isl(nhunt,i).ne.0)write(30+i,830)rtime,
     x median(40,co2mv),tv(nhunt),t2(nhunt) 
1999	continue
        end if 						 	        
c ----------------------------------------------------------------*******
c write 1-sec median, complete data          
          do 1998 i=1,10 
            write(37,837)utime-11.+float(i),
     x      median(4,co2mv((i-1)*4+1)),imask(max(nhunt,1)),nhunt       
1998	continue
c ---------------------------------------------------------------
        goto4
830	format(f9.2,1x,f10.3,1x,2f8.3)
837     format(f9.2,1x,f10.3,1x,i4,1x,i5)
14    continue
      stop 0
994   print*,'Error reading file .111',n111
        stop 994
999   print*,'Error reading file .215',n215
	stop 999
	end
c ++++++++++++++++ functions ++++++++++++++++++++++++++++++++++++
	function median(n,art)
c median of n points;  declare median==real.
code from p227 of Press, 1st ed.
	real arr(100),art(100),median,amedian,a
	integer n
	do 2001 k=1,n
	arr(k)=art(k)
2001    continue
 	do 12 j=2,n
	a=arr(j)
	do 11 i=j-1,1,-1
	if(arr(i).le.a) goto 10
 	arr(i+1)=arr(i)
11      continue
        i=0
10      arr(i+1)=a
12      continue
  	n2=n/2
        if (n2.eq.float(n)/2) amedian = (arr(n2)+arr(n2+1))/2.
        if (n2.ne.float(n)/2) amedian = arr(n2+1)
	median =amedian
2	return
	end
	function huntf(xx,n,x,jlo1)
	INTEGER jlo,n,inc,jhi,jm,huntf,jlo1
	REAL x,xx(n)
c from numerical recipes, 1992 ed.  Given monotonic array xx(1:n) and a value x
c returns value=Jlo such that x is between xx(jlo) and xx(jlo+1).  0,n=exceed
c range. jlo1 on input is the initial guess;  used for searches with rolling
c best guess.  Index put into polint() polynomial interpolator.
	LOGICAL ascnd
	jlo=jlo1
        ascnd=xx(n).gt.xx(1)
        if(jlo.le.0.or.jlo.gt.n)then 
c go to bisection straight off
         jlo=0
	 jhi=n+1
	 goto 3
	end if
	inc=1
	if(x.ge.xx(jlo).eqv.ascnd)then 
c hunt up, increment inc
1           jhi=jlo+inc
            if(jhi.gt.n)then
               jhi=n+1
            else if(x.ge.xx(jhi).eqv.ascnd)then 
c not done hunting
               jlo=jhi
               inc=inc+inc 
c double increment
               goto 1
            end if
         else                           
c hunt down
            jhi=jlo
2           jlo=jhi-inc
            if(jlo.lt.1)then
               jlo=0
            else if(x.lt.xx(jlo).eqv.ascnd)then
               jhi=jlo
               inc=inc+inc
               goto 2
            end if
        end if                          
c end of hunt for bracketting indexes
3 	if(jhi-jlo.eq.1)goto 30
        jm=(jhi+jlo)/2         
c begin biscection
        if(x.gt.xx(jm).eqv.ascnd)then
          jlo=jm
        else
          jhi=jm
        end if
        goto 3
30      huntf=jlo
        return
	END



