c23456789012345678901234567890123456789012345678901234567890123
C
C  Balloon DATA REDUCTION CODE -- LICOR CO2 -- 
C ************   DATA SPLI
C ************  
C  (October, 1992) C  revised Nov 1992 scw 
c
c >>>> revised from split.f to split1.f 2nd SPADE deployment, new channel defs.
C**>>March, 1993, scw
c revised March 1995 to use internal reads instead of awk column strip
c balloon v1.0 May 1996   scw//dirac//  derived split_hi.for from split1.for
C>>>> revised Jan 21, 1997 to include bottle and regulator pressures in the
C 200 Data.
C
C  ***** CR10 DATA ID TABLE *****
C
C  FIELD ID   FIELD LENGTH   FIELD DATA   DATA PERIOD
C       111             43          CO2   4 hz x 10 s
C       200             45      standby          15 s
C       201             16   house keep           1 s
C       215             58   house keep          15 s
c Failure and event record IDs
c       001              3   telemetry <CR>:  ignore this field
C	188		23   initialize/disable
C	204		 3   pump speed test fail/restart needed
C	208		 3   pump temperature alert
C	209		 3   pump restart x10 fail:  5 min delay to retry
C       222             23   Power supply T fail+CNTRL data
C       250		 3   Drop command recvd
C       277              3   float standby mode initiated
C	301		 3   PVTC turned off:  overheated
C	302		 3   GDTC turned off:  overheated
C	303		 3   BPTC turned off:  overheated
C	304		 3   PATC turned off:  overheated
C	400		24   Landing
C  
c  MODE KEYS

c  1 SLOW POWER UP
c  2 FAST POWER UP
c  3 REGULAR STANDBY MODE (TC's enabled)
c  4 PUMP AND GAS FLOW START-UP
c  5 FULL OPERATION / INITIAL CALIBRATION (CALMODE: 1="full", 2="fast"; see 215 data table)
c  6 FULL OPERATION / AUTO CALIBRATION (1 min, timing = ER-2)
c  7 "FLOAT" STANDBY MODE
c  8 PUMP TEMPERATURE ALERT STANDBY MODE
c  9 PUMP RESTART STANDBY MODE
c  10 LANDING MODE -- power disabled
c=============================================================================
C  FIELD 111 DATA: ID, HHMM, SS.SS, 40*[CO2] (4 HZ)
c =============================================================================
c  200 DATA
c  
c  1. 200  Output array identification
c  2. HHMM  2400 time
c  3. Seconds   e.g., 1 or 1.13 or 1.125
c  4. Pr-Amb  [x-zero(T)]*0.31661;<- zero(T_ByPs)=16.995+0.42*T-.002654*T*T torr
c  5. T-cell1 30K Thermistor conversion = TEMP(x) -> deg C
c  6. T-PVint
c  7. T-PVext
c  8. T-mux
c  9. T-rack
c  10. T-instr
c  11. T-batt
c  12. T-GsDk3
c  13. T-ByPs
c  14. T-PmpAy
c  15. Tc-PV Temp Controller conversion = TEMPc(x) -> deg C
c  16. Tc-GD
c  17. Tc-BP
c  18. Tc-PA
c  19. Pr_PV 1.034*(x-500.) -> torr
c  20. Current x*0.02 -> Amps
c  21. T-Pmp#1 30K Thermistor conversion = TEMP(x) -> deg C
c  22. T-Pmp#2 "
c  23. T-PwrSp "
c  24. T-dmy "
c  25. sol-REF Control: 1 = On, 0 = Off
c  26. sol-ZER "
c  27. sol-PRI "
c  28. sol-LS "
c  29. sol-HS "
c  30. sol-SAM "
c  31. sol-VENT "
c  32. PVTC Control: 0= On, 1= Off
c  33. GDTC "
c  34. BPTC "
c  35. PATC "
c  36. P-Ctrl-1 "
c  37. Pmp#1 "
c  38. Pmp#2 "
c  39. P-Ctrl-inl "
c  40. SET-P#1 D-to-A:  0 or Setpoint in mV=3000mV
c  41. SET-P#2 "                           =3000mV
c  42. SET-Pinl "                          =1128mV
c  43. Port-Read Sum of Ports 7&8:   7 high = 64; 8 high = 128; lows=0
c  44. PS-Enable Control: 1 = On, 0 = Off
c  45. MODE See mode key
c  
c =============================================================================
c  
c  201 DATA
c  
c  1. 201 Output array identification
c  2. HHMM 2400 time
c  3. Seconds e.g., 1 or 1.13 or 1.125
c  4. Pr-Amb [x-zero(T)]*0.31661; zero(T-ByPs)=16.995+0.42*T-0.002654*T*T ->
c  5. Pr-Byp [x-zero(T)]*0.1571; zero(T-ByPs)=14.9+0.2475*T-0.001485*T*T -> torr
c  6. Pr-Cell [x-zero(T)]*0.1587; zero(T-PVint)=20,98-0.16*T+0.00051*T*T ->
c  7. Pr-Diff x*4 -> mtorr
c  8. Fl-Byp flow(x)=4.10+0.03837*(x-500.)+1.603e-4*(x-500.)**2 ->sccm
c  9. Fl-Sam "
c  10. Fl-Ref "
c  11. Pr-CalMan [x-zero(T)]* 0.6354;zero(T-PVint)= 29.328-0.06*T+0.000149*T*T -> torr
c  12. Pr-P#1inl [x-zero(T)]*0.1585; zero(T-PmpAy)=4.37+0.3225*T-0.0025*T*T -> torr
c  13. Pr-P#2inl [x-zero(T)]*0.3160; zero(T-PmpAy)=44.72-0.495T+0.005*T*T -> torr
c  14. Speed-P1 x*4
c  15. Speed-P2 x*4
c  16. MODE See mode key
c  
c =============================================================================
c  215 DATA
c  1. 215 Output array identification
c  2. HHMM 2400 time
c  3. Seconds e.g., 1 or 1.13 or 1.125
c  4. T-cell1 30K Thermistor conversion = TEMP(x) r (C
c  5. T-cell2 "
c  6. T-PVint "
c  7. T-PVext "
c  8. Stat-Pmp1 x*2
c  9. Stat-Pmp2 x*2
c  10. T-mux 30K Thermistor conversion = TEMP(x) r (C
c  11. T-rack "
c  12. T-instr "
c  13. T-batt "
c  14. Preg-REF [x-6.7]*0.06547 -> psi
c  15. Preg-PRI [x+69.2]*0.06602 -> psi
c  16. Preg-LS [x-100.7]*0.06625 -> psi
c  17. Preg-HS [x-109.8]*0.06559 -> psi
c  18. HiP-REF [x-61.7]*1.30548 -> psi
c  19. HiP-PRI [x+38.2]*1.29366 -> psi
c  20. HiP-LS [x-24.6]*1.30662 -> psi
c  21. HiP-HS [x-16.1]*1.31579 -> psi
c  22. T-GsDk2 30K Thermistor conversion = TEMP(x) -> deg C
c  23. T-GsDk3 "
c  24. T-ByPs "
c  25. T-PmpAy "
c  26. Tc-PV Temp Controller conversion = TEMPc(x) -> deg C
c  27. Tc-GD "
c  28. Tc-BP "
c  29. Tc-PA "
c  30. Det-Rdy Ready ( 1100 mV
c  31. Pr_PV 1.034*(x(500) r torr
c  32. Current x*0.02rAmps
c  33. T-Pmp#1 30K Thermistor conversion = TEMP(x) -> deg C
c  34. T-Pmp#2 "
c  35. T-PwrSp "
c  36. T-dmy "
c  37. sol-REF Control: 1 = On, 0 = Off
c  38. sol-ZER "
c  39. sol-PRI "
c  40. sol-LS "
c  41. sol-HS "
c  42. sol-SAM "
c  43. sol-VENT "
c  44. PVTC Control: 0= On, 1= Off
c  45. GDTC "
c  46. BPTC "
c  47. PATC "
c  48. P-Ctrl-1 "
c  49. Pmp#1 "
c  50. Pmp#2 "
c  51. P-Ctrl-inl "
c  52. SET-P#1 D-to-A:  0 or Setpoint in mV =3000mV
c  53. SET-P#2 "                                             =3000mV
c  54. SET-Pinl "                                             =1128mV
c  55. Port-Read Sum of Ports 7&8:   7 high = 64; 8 high = 128; lows = 0
c  56. PS-Enable Control: 1 = On, 0 = Off
c  57. FLOATcnt Seconds elapsed since altitude higher than 10 Torr not cnt'd after drp cmd
c  58. CalMode 1 = full (8 min: z,ls,hs,pri,repeat); 2 = fast (4min:z,ls,hs,pri/1min ea)
c  
c =============================================================================
c conversion functions
c  
c  TEMPc(x)= - 17.415 + 0.03805*x - 6.503e-6*x*x
c note change of sign from ER-2:  these are differential channels
c  
c  TEMP(x1):   x=-x1; xx = 30100.*x/(2500.-x)
c  y = alog(xx)
c  z = 9.3548e-4 + (2.2071e-4 + 6.8076e-8*y + 1.2407e-7*y*y)*y  
c  TEMP=1/Z-273.15
c  note these are still CR10 single-ended channels, thus the first line +/-
C  ***** END OF TABLE *****
C
	implicit real*8 (a-h,o-z)
      CHARACTER INPUTDATA*24,cr10line*512
      real*8 dip(58)
      REAL*8 UTIME
      INTEGER id,HOUR,MINT,nummit(7),ncod(400)
	logical lfirst
      data nummit/42,52,15,2,57,22,23/ 
C nummit is (number of data points per line -1 <ID NOT CNTD>) >> rec. codes 1-7
C  1==111;2==200;3==201; 4==001,204,208,209,250,277,301,302,303,304;
c  5==215;6==188,222;7==400
c obsolete codes are 210, 203.  
	data ncod/4,98*0,6,10*0,1,76*0,6,11*0,2,3,0,0,4,0,0,0,4,
     x  4,0,0,0,0,0,5,6*0,6,27*0,4,26*0,4,23*0,4*4,95*0,7/
C
C Enter Input Data File : code H921104.raw (H921104.raw in separate subdir/mult flts
C any file name is acceptable, characters (2:7) will be used to tag the other files.
	open(55,file='infile',status='old')
c finds the name of the input file in 'infile', usually HYYMMDD.RAW
      READ(55,'(A24)') INPUTDATA
      OPEN(12,FILE=INPUTDATA,STATUS='OLD',recl=512,access='sequential',
     x action='read')
      OPEN(13,FILE='D'//INPUTDATA(2:7)//'.BID',STATUS='unknown',recl=512,access='sequential')
      OPEN(14,FILE='D'//INPUTDATA(2:7)//'.BRC',STATUS='unknown',recl=512,access='sequential')
      OPEN(21,FILE='D'//INPUTDATA(2:7)//'.111',STATUS='unknown',recl=512,access='sequential')
      OPEN(92,FILE='D'//INPUTDATA(2:7)//'.ERR',STATUS='unknown',recl=512,access='sequential')
      OPEN(22,FILE='D'//INPUTDATA(2:7)//'.200',STATUS='unknown',recl=512,access='sequential')
      OPEN(23,FILE='D'//INPUTDATA(2:7)//'.201',STATUS='unknown',recl=512,access='sequential')
      OPEN(25,FILE='D'//INPUTDATA(2:7)//'.215',STATUS='unknown',recl=512,access='sequential')
      OPEN(26,FILE='D'//INPUTDATA(2:7)//'.ETC',STATUS='unknown',recl=512,access='sequential')
      WRITE(13,*) ' ID = BAD CR10 RECORD:  WRONG ID : ',INPUTDATA
      WRITE(14,*) ' ID = BAD CR10 RECORD:  WRONG # fields or data type: ',INPUTDATA
      WRITE(21,*) ' ID = 111 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(22,*) ' ID = 200 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(23,*) ' ID = 201 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(25,*) ' ID = 215 ,  FLIGHT DATE : ',INPUTDATA
      WRITE(26,*) ' FLIGHT DATE : ',INPUTDATA
      WRITE(26,*)' ID = 001 100 188 204 208 209 222 250 277 301 302 303 304 400'
      n1=0 
	nbadid=0
	nbaddata=0
C counter for # records
	utime0=-999.
	nneg=0
	idp=99
      tpvint=99
      tbypass=99
      tpmpay=99 
C intialize temp data to be passed between files:  read in 215, needed 215,201
	lfirst=.true.
10	n1=n1+1
	read(12,'(a)',end=90,err=599)cr10line
	read(cr10line,*,err=1299)id,hhmm,secd
c internal read **rev March 1995**
	if(100.*secd.ne.int(100*secd))write(99,789)n1,secd,cr10line(1:20)
789	format(i5,f10.5,a)
	if(id.ne.400)then
      HOUR=HHMM/100.
      MINT=HHMM-HOUR*100
	else
      HOUR=secd/100.
      MINT=secd-HOUR*100
	secd=0.
	endif
	if(.not.lfirst)then
         if(HOUR*3600.+MINT*60.+SECD.lt.firstt)hour=hour+24
	end if 
      UTIME=HOUR*3600.+MINT*60.+SECD 
	if(lfirst)firstt=utime
	if(id.eq.111)lfirst=.false.  
	if(utime.lt.utime0)then
792	format('neg time diff, rec. #',i5,2f10.3,2i6)
		if(id.ne.215.or.idp.ne.201)then
		write(92,792) n1,utime,utime0,id,idp
		nneg=nneg+1
		endif
	endif
	utime0=utime
C set first time to first '111'
check for bad ID (first record on the cr10line)
	if(id.lt.0 .or. id.gt.400)go to 999
        n=ncod(ID)
        if(n.eq.0)go to 999
	nunit=min(26,(20+n))
	if(n.eq.4)nunit=26
c units 24 and 27 map to 26 (etc file)
        READ(cr10line,*,END=89,ERR=1299) ID,(dip(i),i=1,nummit(n))
c indices in dip() are 1 less than the rank in the table above 
        if(n.le.2)then 
C id=111,200
        write(nunit,20) UTIME,HOUR,MINT,SECD
        if(n.eq.2)then
      tpvint=dip(5)
      tbypass=dip(20)
      tpmpay=dip(21) 
	write(nunit,30) (dip(i),i=3,nummit(n)),tbypass
	endif
        if(n.eq.1)write(nunit,30) (dip(i),i=3,nummit(n))
        end if
	if(n.eq.3)then 
Cid=201: pass temps from 215 or from 200 to 201 
        write(nunit,20) UTIME,HOUR,MINT,SECD
        write(nunit,30) (dip(i),i=3,nummit(n)),tpvint,tbypass,tpmpay
        end if
        if(n.eq.5)then 
C id=215 
	write(nunit,20) UTIME,HOUR,MINT,SECD
        write(nunit,30) (dip(i),i=3,nummit(n))
      tpvint=dip(5)
      tbypass=dip(23)
      tpmpay=dip(24)
c indices for tp.. are [(position in 215 array) -1] (id does not go into dip) 
	end if
        if(n.eq.6)WRITE(26,140) ID,UTIME,HOUR,MINT,SECD, (dip(i),i=3,nummit(n))
        if(n.eq.7)WRITE(26,140) ID,UTIME,HOUR,MINT,SECD, (dip(i),i=3,nummit(n))
20    FORMAT(F8.1,2X,I2,2X,I2,2X,F5.2)
30    FORMAT(8(F9.2,1X))
140    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2(/8(f9.2,1x)))
40    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2)
45    FORMAT(I3,2X,F8.1,2X,I2,2X,I2,2X,F5.2,2X,F2.0)
	idp=id
        goto 10
89      print *,'end of file, unit 12'
90      print *,'SPLIT_HI normal exit, # records read =',n1
	print*,'bad rec ID=',nbadid,'; bad data fields=', nbaddata
	if(nneg.eq.0)print*,'There were',nneg,' neg. time intervals'
	if(nneg.ne.0)print*,'WARNING, there were',nneg,' neg. time intervals'
      CLOSE(12)
      CLOSE(21)
      CLOSE(22)
      CLOSE(23)
C**     CLOSE(24)
      CLOSE(25)
      CLOSE(26)
        stop 0
999     write(13,'(a)')cr10line
	write(14,*)' record #',n1
	nbadid=nbadid+1
	go to 10
599     write(14,*)' unreadable record',n1
	nbaddata=nbaddata+1
        go to 10
1299    write(14,'(a)')cr10line
	write(14,*)' record #',n1
	nbaddata=nbaddata+1
        go to 10
        end


