#create file metadata from the spb files. "file.bg" must contain the name of of the
#file containing the background spectra, and "file.raw" the name of the "..RAW.spb" file.
system("echo file.bg | ./read_spb > logfile.bg")
system("echo file.raw | ./read_spb > logfile.raw")
NP.bg<-scan("NP_BG.data") ; npt<-NP.bg[1] ; npar<-NP.bg[2]
#  
# read in the QCL data files extracted from 'BG' and 'RAW' files
#   
baseline <- matrix(scan("qcl__BG.data"),ncol=npt+npar,byrow=T) 
#  
bgtime <- baseline[,2]         # time stamp (s)             
bginttime <- baseline[,3]        # integration time stamp (s)
bgpress <- baseline[,4]         # sample pressure (torr) 
bgtemp <- baseline[,5]          # sample temperature (K)
bgpar1 <- baseline[,6]          # parameter 6 
bgpar2 <- baseline[,7]          # parameter 7 
bgpar3 <- baseline[,8]          # parameter 8 
#   
baseline <- t(baseline[,(npar+1):(npar+npt)])
baseline[baseline==0] <- NA
timebg <- bgtime - (floor(min(bgtime)/10000.)*10000.) 
#               numbers of points per spectrum--global header stripped by read_spb
NP.raw<-scan("NPRAW.data") ; npt.raw<-NP.raw[1] ; npar.raw<-NP.raw[2]
#               still need number of points per laser--test file had no CO laser data
dumm.raw <- matrix(scan("qcl_RAW.data"),ncol=npt.raw+npar.raw,byrow=T) 
#  
timesp.raw <- dumm.raw[,2]         # time stamp (s)             
inttime.raw <- dumm.raw[,3]        # integration time stamp (s)
spress.raw <- dumm.raw[,4]         # sample pressure (torr) 
stemp.raw <- dumm.raw[,5]          # sample temperature (K)
spar1.raw <- dumm.raw[,6]          # parameter 6  
spar2.raw <- dumm.raw[,7]          # parameter 7 
spar3.raw <- dumm.raw[,8]          # parameter 8 
#   
spec.raw <- t(dumm.raw[,(npar.raw+1):(npar.raw+npt.raw)])
spec.raw[spec.raw==0] <- NA
times.raw <- timesp.raw - (floor(min(timesp.raw)/10000.)*10000.) 
nspec.raw<-ncol(spec.raw)           # spectra
#
#find the index of the before and after backgrounds, for each spectrum. This should be done
#with a merged file containing all the data, requiring reading up to 6 spb files.
bb<-timebg ; spec.bg<-baseline   # now find the break points
 if(min(times.raw)<timebg[1]){ bb<-c(min(times.raw),bb) ; spec.bg<-cbind(baseline[,1],spec.bg)}
if(max(times.raw)>=timebg[length(timebg)]){
bb<-c(bb,max(times.raw));spec.bg<-cbind(spec.bg,baseline[,ncol(baseline)])}
times.bg<-bb
uu<-cut(times.raw,breaks=bb,labels=F,include.lowest=T)  # <<=  assign bg interval to each sample spec.
#
#then compute the background-corrected spectra for each. Find two sets of
#scaling factors, and blend these factors. Thus we will do double work.
#
spec.1<-NULL ; spec.2<-NULL
for(i in 1:ncol(spec.raw)){
spec.1<-cbind(spec.1,spec.raw[,i]/spec.bg[,uu[i]])
spec.2<-cbind(spec.2,spec.raw[,i]/spec.bg[,uu[i]+1])
}

# -- note uu==1 and uu==7 give invalid spectra for our test file.

#first, plot them all
#matplot(type="l",x=matrix(rep(1:nrow(spec.raw),ncol(spec.raw)),ncol=ncol(spec.raw)),y=(spec.raw))
#
#create a mean spectrum, just to look at
#fit marks, line 2= ch4, line 3 = n2o
##nf.l2<-c(55,105) ; nf.l3<-c(105,165) # channels for the fit, lines 2,3
nf.l2<-c(25,95) ; nf.l3<-c(115,165) # channels for the fit, lines 2,3
NN.l2<-nf.l2[1]:nf.l2[2] ; NN.l3<-nf.l3[1]:nf.l3[2]; NN<-nf.l2[1]:nf.l3[2]
spec.mean.l2<-apply(spec.1[NN.l2,],1,mean)
spec.mean.l3<-apply(spec.1[NN.l3,],1,mean)
#spec.mean<-apply(spec.1[NN,],1,mean)       # proxy for suitable standards
spec.mean<-apply(spec.1,1,mean)       # proxy for suitable standards
# note the tail of the CH4 line affects N2O, so fit them altogether, or extrapolate Lorenztian tail,
# or insert a gap so the points used for the particular line are free of influence.
#inspect the frequency shifts
savgol.3.3.3.0<-c(-0.095238,0.142857, 0.285714, 0.333333, 0.285714, 0.142857, -0.095238)
savgol.3.3.3.1<-c(8.7302e-02, -2.6587e-01, -2.3016e-01, 8.2115e-18, 2.3016e-01, 2.6587e-01,-8.7302e-02)
# find zero crossings of mean spectrum
s.mean<-filter(spec.mean,savgol.3.3.3.0,"conv")
y.mean<-filter(spec.mean,savgol.3.3.3.1,"conv")
z.cross<-which(y.mean[1:(length(y.mean)-1)] >0 & y.mean[2:length(y.mean)]<=0)
z.cross<-z.cross[(abs(z.cross-79)<3)|(abs(z.cross-134)<3)] # drop the little line #find the two zero crossings
#
z1c<-lsfit((z.cross[1]-1):(z.cross[1]+1) ,y.mean[(z.cross[1]-1):(z.cross[1]+1)])$coef
z1<-(-1)*z1c[1]/z1c[2] # add trapping zero here
#
z2c<-lsfit((z.cross[2]-1):(z.cross[2]+1) ,y.mean[(z.cross[2]-1):(z.cross[2]+1)])$coef
z2<-(-1)*z2c[1]/z2c[2] # add trapping zero here
#---------------------------------------------------------------------------------------
#find the channel shift for each spectrum
ZC.1<-NULL ; ZC.2<-NULL
l2.a<-z1-2;l3.a<-z2+2   ## assume peak will move by less than 2 channels
NNN<-1:nrow(spec.1)
for(i in 1:ncol(spec.1)){
y<-filter(spec.1[,i],savgol.3.3.3.1,"conv")
x<-which(y[1:(length(y)-1)] >0 & y[2:length(y)]<=0)
z.cross<-x[((x>l2.a-3)&(x<l2.a+3))|((x>l3.a-3)&(x<l3.a+3))]
z1c<-lsfit(NNN[(z.cross[1]-1):(z.cross[1]+1)] ,y[(z.cross[1]-1):(z.cross[1]+1)])$coef
z1<-(-1)*z1c[1]/z1c[2] # add trapping zero here
z2c<-lsfit(NNN[(z.cross[2]-1):(z.cross[2]+1)] ,y[(z.cross[2]-1):(z.cross[2]+1)])$coef
z2<-(-1)*z2c[1]/z2c[2] # add trapping zero here
ZC.1<-cbind(ZC.1,c(z1,z2))
# post background used
y<-filter(spec.2[,i],savgol.3.3.3.1,"conv")
x<-which(y[1:(length(y)-1)] >0 & y[2:length(y)]<=0)
z.cross<-x[((x>l2.a-3)&(x<l2.a+3))|((x>l3.a-3)&(x<l3.a+3))]
z1c<-lsfit(NNN[(z.cross[1]-1):(z.cross[1]+1)] ,y[(z.cross[1]-1):(z.cross[1]+1)])$coef
z1<-(-1)*z1c[1]/z1c[2] # add trapping zero here
z2c<-lsfit(NNN[(z.cross[2]-1):(z.cross[2]+1)] ,y[(z.cross[2]-1):(z.cross[2]+1)])$coef
z2<-(-1)*z2c[1]/z2c[2] # add trapping zero here
ZC.2<-cbind(ZC.2,c(z1,z2)) # found indistinguishable from ZC.1
}
#
#we will want to compute the peak position for each line, remove outliers by defining an acceptable range
# from actual data, then shift and stretch the spectra before computing the ratio.  We can see the
# effect of the jiggling by not doing that !
# 1st do the fitting without concern for channel shifting
# blend the results; separate the lines with white space to reduce cross-talk
r1.1<-apply(spec.1[NN.l2,]/spec.mean[NN.l2],2,mean)
r1.2<-apply(spec.2[NN.l2,]/spec.mean[NN.l2],2,mean)
r2.1<-apply(spec.1[NN.l3,]/spec.mean[NN.l3],2,mean)
r2.2<-apply(spec.2[NN.l3,]/spec.mean[NN.l3],2,mean)
s1.1<-apply(spec.1[NN.l2,]/spec.mean[NN.l2],2,sd)
s1.2<-apply(spec.2[NN.l2,]/spec.mean[NN.l2],2,sd)
s2.1<-apply(spec.1[NN.l3,]/spec.mean[NN.l3],2,sd)
s2.2<-apply(spec.2[NN.l3,]/spec.mean[NN.l3],2,sd)
R.0<-cbind(times.raw,r1.1,r1.2,r2.1,r2.2,s1.1,s1.2,s2.1,s2.2);
dimnames(R.0)<-list(NULL,c("time","ch4a","ch4p","n2oa","n2op","sig.ch4a","sig.ch4p","sig.n2oa","sig.n2op"))
#note the divided spectra have a (very weak) 1st dervi signal.  Could fit a shift to null this out.
#compute the time-weighted ratios
ww<-(times.raw-times.bg[uu])/(times.bg[uu+1]-times.bg[uu])
ch4b<-r1.1*(1-ww) + r1.2*ww
n2ob<-r2.1*(1-ww) + r2.2*ww
R.0<-cbind(R.0,ch4b,n2ob)
######### > sd(n2ob) [1] 0.0005672626 #### sd(ch4b) [1] 0.0006105489 
#########> mean(ch4b) [1] 0.9997547 #### mean(n2ob) [1] 0.999829  
######### sd CH4 = 1.1 ppb, N2O = .17 ppb
#   ----------------------------------------end of main code, start test codes-------------------
#now shift the channel using akima's original spline interplolation; we will fit the two lines 
#separately : Line 2, channels 53 to 103; line 3, channels 103 to 155
library(akima)
R.s<-NULL 
for(i in 1:ncol(spec.1)){
dum.1<-aspline(x=NNN -(ZC.1[1,i]+ZC.1[2,i])/2 +(z1+z2)/2,y=spec.1[,i],xout=NNN)$y
dum.2<-aspline(x=NNN -(ZC.2[1,i]+ZC.2[2,i])/2 +(z1+z2)/2,y=spec.2[,i],xout=NNN)$y
p1.1<-mean(dum.1[NN.l2]/spec.mean[NN.l2])
p1.2<-mean(dum.2[NN.l2]/spec.mean[NN.l2])
p2.1<-mean(dum.1[NN.l3]/spec.mean[NN.l3])
p2.2<-mean(dum.2[NN.l3]/spec.mean[NN.l3])
R.s<-rbind(R.s,c(times.raw[i],p1.1,p1.2,p2.1,p2.2))
}
# what we can do here, is to estimate the ratios without moving the line, then use
# nls() to determine both the best slope and the best shift.  Other changes such as
#baseline might be included, but some care is needed on that.  It could be slow due to
# the nls().
dimnames(R.s)<-list(NULL,c("time","ch4a","ch4p","n2oa","n2op"))
ch4b<-p1.1*(1-ww) + p1.2*ww
n2ob<-p2.1*(1-ww) + p2.2*ww
R.s<-cbind(R.s,ch4b,n2ob)

R.f<-NULL
for(i in 1:ncol(spec.1)){
f1.1<-lsfit(spec.mean[NN.l2],spec.1[NN.l2,i])$coef
f1.2<-lsfit(spec.mean[NN.l2],spec.2[NN.l2,i])$coef
f2.1<-lsfit(spec.mean[NN.l3],spec.1[NN.l3,i])$coef
f2.2<-lsfit(spec.mean[NN.l3],spec.2[NN.l3,i])$coef
R.f<-rbind(R.f,c(times.raw[i],f1.1[2],f1.2[2],f2.1[2],f2.2[2],f1.1[1],f1.2[1],f2.1[1],f2.2[1]))
}
dimnames(R.f)<-list(NULL,c("time","ch4a","ch4p","n2oa","n2op","ch4a.0","ch4p.0","n2oa.0","n2op.0"))
ch4b<-R.f[,"ch4a"]*(1-ww) + R.f[,"ch4p"]*ww
n2ob<- R.f[,"n2oa"]*(1-ww) + R.f[,"n2op"]*ww
R.f<-cbind(R.f,ch4b,n2ob)
## sd(R.f[,"ch4b"]) [1] 0.001357643 # sd(R.f[,"ch4b"])*1750 [1] 2.375876 == much inferior

#question remains open about ref instead of zero gas: would get similar *ratios to conc in the null gas*
# the std meas. then simply determing the scale and non-linearity.  But we don't get information on the
# baseline

##re-naming for clarity: l2 & rel-- lc4  ; l3 -- ln2
#    spec.1 => spec.a  spec.2 => spec.p  likewise rel
# ------------------------------start drawing figures-----------------------------------
#---------------------------------------------------------------------------------------
postscript("Fig.mean_spec.ps",horizontal=F)
par(mfrow=c(2,1))
par(mar=c(3,4,1,0.2))
plot(NN,spec.mean,type="o",pch=3)
 abline(v=c(z1,z2),h=1000,col="red",lty=2)
mtext(side=3,at=c(z1,z2),text=paste(round(c(z1,z2),3)),col="red")
lines(NN,s.mean,col="green")
par(mar=c(4,4,0.2,0.2))
plot(NN,y.mean,type="o",pch=4,xlab="Channel # NN",ylab="dS/dNN")
 abline(v=c(z1,z2),lty=2,col="red")
 abline(z1c,col="blue")
 abline(h=0,lty=2)
 abline(z2c,col="blue")
dev.off()
#
postscript("Fig.spectral_stretch.ps",horizontal=F)
par(fin=c(6.5,6.5),mar=c(4,4,2,2))
plot(t(ZC),xlab="Peak Position Line 2",ylab="Peak Position Line 3")
points(t(ZC)[nbad,],col="red")
uu<- UU$coef
abline(uu,col="red")
mtext(line=1,side=3,text=paste("Slope =",round(uu[2],3)))
mtext(line=-1,side=3,text="Red pts marked bad",col="red")
 qqnorm(UU$resid,ylab="Residual from Spectral Shift fit, L2 vs L3")
 abline(h=c(2.8*sig,-2.8*sig),col="red")
dev.off()
#  
postscript("Fig.scaled.ps",horizontal=T)
par(mfrow=c(2,2),mar=c(4,4,1.5,.5))
plot(R.0[,c(1,2)],xlab="time",ylab="Relative Conc",ylim=c(.997,1.003))
points(R.0[,c(1,3)],col="red")
mtext(side=3,col="red",line=-1,"Post interval BG: CH4")
mtext(side=3,col="black",line=-2,"Ante interval BG")
abline(v=times.bg,h=1,lty=2,col="green")
plot(R.0[,c(1,4)],xlab="time",ylab="Relative Conc",ylim=c(.997,1.003))
points(R.0[,c(1,5)],col="red")
abline(v=times.bg,h=1,lty=2,col="green")
mtext(side=3,col="red",line=-1,"Post interval BG: N2O")
mtext(side=3,col="black",line=-2,"Ante interval BG")
plot(R.0[,c(1,6)],xlab="time",ylab="Relative Conc CH4, BLENDED")
abline(v=times.bg,h=1,lty=2,col="green")
plot(R.0[,c(1,7)],xlab="time",ylab="Relative Conc N2O, BLENDED")
abline(v=times.bg,h=1,lty=2,col="green")
dev.off()
#
postscript("Fig.spectral_shifts.ps",horizontal=F)
par(mfrow=c(2,1),mar=c(3,4,.2,.2))
plot(times.raw,ZC.1[1,],ylab="Line 2 Zero Cross (Ch #)",xlab="")
plot(times.raw,ZC.1[2,],ylab="Line 3 Zero Cross (Ch #)",xlab="Time Stamp")
plot(times.raw,ZC.1[1,]-ZC.1[2,],ylab="Line 2 - line 3 Zero Cross (Ch #)",xlab="")
abline(h=mean(ZC.1[1,]-ZC.1[2,]),col="red",lty=2)
plot(ZC.1[1,],ZC.1[2,],ylab="Line 3 Zero Cross (Ch #)",xlab="Time Stamp")
UU<- lsfit(ZC.1[1,],ZC.1[2,])
sig<-sqrt(var(UU$resid))
nbad<-which(abs(UU$resid)>2.8*sig)
points(ZC.1[1,nbad],ZC.1[2,nbad],col="red"); abline(UU$coef,col="red",lty=2)
dev.off()
####################### baseline subtracted data (ratioed) ##########
#dumm <- matrix(scan("qcl_spectral.data"),ncol=npar+npt,byrow=T)         #
##                                                                  #
#timesp <- dumm[,2]         # time stamp (s)                        #
#inttime <- dumm[,3]        # integration time stamp (s)            #
#spress <- dumm[,4]         # sample pressure (torr)                #
#stemp <- dumm[,5]          # sample temperature (K)                #
#spar1 <- dumm[,6]          # parameter 6                           #
#spar2 <- dumm[,7]          # parameter 7                           #
#spar3 <- dumm[,8]          # parameter 8                           #
##                                                                  #
#spec <- t(dumm[,(npar+1):(npar+npt)])                                            #
#spec[spec==0] <- NA                                                #
##                                                                  #
#
#nspec <- length(timesp)
#times <- timesp - (floor(min(timesp)/10000.)*10000.) 
#====================raw spectra===========================
