       program read_spb
C  
c Program reads a file, a file giving the name of the spb file is read from standard input
c (The name itself is not given so that full paths can be conveniently put into the name) 
c Then read_spb calls the shell script len which puts the number of
c bytes in the spb file into a file named 'len.file'.  This is read, and
c the open statement is then executed for the binary file.
c the binary file is then read into x() and disaggregated, with output put
c into files with names derived from the last 3 char ahead of '.spb' file name.
c CAUTION -- existing files will be overwritten
       real*8 x(909940), spect(3600,300), param(3600,30)
       character*80 a,dummy,filename
C     
        read(5,*)filename
        nf=len_trim(filename)
        open(unit=1,file=filename(1:nf),status='old')
        read(1,*)dummy
        print*,'read_spb: file=',dummy
        nn1=len_trim(dummy)
        call system('./len '//dummy(1:nn1))
        open(unit=2,file='len.file',status='old')
        read(2,*)len_file
        print*,'Number of bytes in spb file=',len_file
       open(file=dummy(1:nn1),status='old',unit=1,
C    x        recl=7279520,access='SEQUENTIAL',form='UNFORMATTED')
     x        recl=len_file,access='SEQUENTIAL',form='UNFORMATTED')
        n4=nn1-4
        n6=nn1-6
        open(file='qcl_'//dummy(n6:n4)//'.data',status='unknown'
     x       ,unit=15)  
        open(file='NP'//dummy(n6:n4)//'.data',status='unknown',unit=25) 
c       open(file='qcl_'//dummy(n6:n4)//'_output.data',status='unknown',unit=16)  
        numx=len_file/8 
C  
C  
c               if(dummy(n6:n4).eq.'_BG') go to 92
c               if(dummy(n6:n4).eq.'RAW') go to 91
c        print*,'recognized file type not found'
c        stop 93
91       read(1,REC=1,IOSTAT=ierror) (x(i),i=1,numx)
C         if (ierror .NE. 0) goto 900  
       print *, ierror
C  Determine the parameters for this data set: 
C     npar - number of parameters for each spectrum 
C     npt  - number of channels per spectrum  
C  
        write(*,200) (i,x(i),i=1,4)
        npar = int(x(3)) 
        npt = int(x(4)) 
        nparp=8
        write(25,'(i5,1x,i4)')npt,nparp
        print*," Nparam, Npoints: ", npar, npt 
        print*, "                " 
        kk = 4 
        nspec=(len_file - 4)/(npar+npt)/8
        do j=1,nspec
          do i=1,npar
            kk = kk + 1
            param(j,i) = x(kk)  
            if (param(j,1) .EQ. 0.0) goto 70  
            if (i .eq. 1) param(j,i) = param(j,i)/1000.  
          enddo 
          print*," Time Stamp: ",j, param(j,1)   
          print*," Test: ",param(j,2),param(j,3),param(j,4) 
          print*, "        "
          do i = 1,npt 
            kk = kk + 1
            spect(j,i) = x(kk) 
          enddo 
        enddo   
 
 70     print*, "        "
C  
C  Write the spectra out into format readable by R 
C   
        do jj = 1,nspec  
          if (param(jj,1) .EQ. 0.0) goto 900  
          
c         write(16,100) jj,param(jj,1)
c         write(16,101) (param(jj,i),i=2,7)  
c         write(16,102)    
c         write(16,103) (spect(jj,i),i=1,npt)
C
          write(15,201) jj,(param(jj,i),i=1,7) 
          write(15,103) (spect(jj,i),i=1,npt)
        enddo  
 100     format(1X," Time Stamp: ",I5,3X,F20.5)  
 101     format(1x," Parameters: ",6F10.4)  
 102     format(1x," Spectrum: ")  
 103     format(2X,5F15.3)   
 200     format(2X,I5,F15.3)   
 201     format(1x,I5,1X,F20.5,6F9.3)  

 900    print*, 'error code=',ierror
        if(ierror.ne.0)print*,'FAILED'
        close(1) 
        close(15) 
        close(25) 
c       close(16) 
        stop 

        end
